#include "gpstdlib.h"

extern "C"
{
#include "gpdef.h"
#include "gpstdio.h"
#include "gpgraphic.h"
#include "gpfont.h"
#include "./res.c"
}

#define	LCD_WIDTH	320	//width of LCD
#define	LCD_HEIGHT	240	//height of LCD
#define	BG_WIDTH	320	//width of background image
#define	BG_HEIGHT	240	//height of background image

#define YES   1
#define NO    0
#define SUCCESS 1
#define FAIL    0
#define ON   1    // Timer state
#define OFF  0    //
#define ALIVE 1   // PlayerState
#define WAIT 2   // PlayerState
#define DEAD  0   // 
#define TRUE 1
#define FALSE 0

	int Screen[21][12];
	int OldScreen[21][12];      //   ũ ̺
	int NowX, NowY, RotateNum, crashCount;
	int BlockNum;
	int NextBlockNum;
	int PlayerState;
	int FullLineNum;
	int HiScore;
	int GameOver;
	int Stage=0;
	int Pause=ON;
	ulong m_size;
	int	Start();
	void init();
	void End();
	int  Update();
	void ChangeScreen();
	void PutFps();
	void Wait(long Delay);
	void resume();
	void InitScreenTable();
	void CheckFullLine();
	void UpdateScreenTable();
	int DownMove();
	void Rotate();
	void Rotate2();
	void RightMove();
	void LeftMove();
	int BlockCanMove(int x,int y);
	void DrawNextBlock();
	void DrawBlock();
	void InitMedia();
	void StartGame();
	void InitBlockState();
	void GpRect( int left, int top, unsigned char color_line, unsigned char color );
	

GPDRAWSURFACE gpDraw[2];
int nflip;
/*
extern const unsigned int	bg[320][60];	//size : 320 * 240
extern const unsigned char tetrisbg[16172];
extern const unsigned short bgsound[1240312];
extern int  Block[7][4][4][4];
extern const unsigned int tet_bg[320][60];

*/
int	g_key_pressed = 0;		//list of buttons pressed in curent loop
int	g_key_pressed_old = 0;	//list of buttons pressed in previous loop
int	g_key_down = 0;			//list of buttons with key-down event
int	g_key_up = 0;			//list of buttons with key-up buttons

int n_tmr0;
int tmp_tmr0;
int score_buf;
int NowCheckLine=ON;

F_HANDLE h_file;
F_HANDLE h_rfile;

void ProcTimer0(void);
void init()
{
	ERR_CODE err_code;
	
	GpFatInit();
	err_code = GpRelativePathSet("gp:\\gpmm"); 
	if (err_code != SM_OK) HiScore+=50;//return;

	err_code = GpFileCreate("tet.sav", NOT_IF_EXIST, &h_file);
	if (err_code != SM_OK) HiScore+=4;
	GpFileClose(h_file);

	err_code = GpRelativePathSet("gp:\\gpmm"); 
	if (err_code != SM_OK) HiScore=1000;//return;

	err_code = GpFileOpen("tet.sav", OPEN_R, &h_file);
	if (err_code != SM_OK) HiScore+=1;//return;

	err_code=GpFileGetSize("tet.sav", &m_size);
	if (err_code != SM_OK) HiScore+=2;//return;

	err_code = GpFileRead(h_file, &score_buf, 8, &m_size); 

	HiScore = score_buf; //ְ Ͽ о  ִ´.
	
	GpFileClose(h_file);
}
void SetKeyStatus(void)
{
	int	g_key_pressed = GpKeyGet();
	int	k;
	g_key_down = 0;
	g_key_up = 0;
	for(k = 0x0001 ; k <= 0x2000 ; k <<= 1)
	{
		//if pressed in previous loop & NOT pressed in current loop, key-up event has occurred
		if((g_key_pressed_old & k) && !(g_key_pressed & k))	g_key_up |= k;
		//if NOT pressed in previous loop & pressed in current loop, key-down event has occurred
		if(!(g_key_pressed_old & k) && (g_key_pressed & k))	g_key_down |= k;
	}
	g_key_pressed_old = g_key_pressed;
}

void StartGame()
{
	InitScreenTable();
	PlayerState = ALIVE;
	NextBlockNum = GpRand()%7;
	FullLineNum = 0;
	Stage = 1;
	NowCheckLine=ON;
	Pause = ON;
	InitBlockState();

	if(GPOS_ERR_ALREADY_USED == GpTimerOptSet(0,Stage,0,ProcTimer0))	GpTimerKill(0);
	GpTimerSet(0);
}


void GpMain(void *arg)
{
	int	i;
	char tmp_string[256];
	char tmp_string2[256];
	
	init();

	for(i = 0 ; i < 2 ; i++)
	{
		GpLcdSurfaceGet(&gpDraw[i], i); 
	}

	GpSrand((int)GpTickCountGet());

	GpSurfaceSet(&gpDraw[0]);
	
	nflip = 1;
	
	while(1)
	{
		SetKeyStatus();
		if (g_key_down & GPC_VK_START)
			switch(PlayerState)
			{
				case DEAD:
					StartGame();
					break;
				case ALIVE:
					if (Pause != OFF) Pause = OFF;
					else Pause = ON;
					break;
				case WAIT:
					PlayerState=DEAD;
					break;

			}	
		
		if ( (Pause != OFF) && (PlayerState==ALIVE) )
		{
			if (g_key_down & GPC_VK_LEFT)
				LeftMove();
			if (g_key_down & GPC_VK_RIGHT)
				RightMove();
/*			if (g_key_down & GPC_VK_UP)
				Rotate();*/
			if (g_key_down & GPC_VK_FA)
				Rotate();
			if (g_key_down & GPC_VK_FB)
				while(DownMove());
			if (g_key_down & GPC_VK_SELECT)
				while(DownMove());
			if (g_key_down & GPC_VK_DOWN)
				DownMove();
		}
		
		if (PlayerState!=DEAD)
		{
			GpBitBlt(NULL, &gpDraw[nflip], 0, 0, BG_WIDTH, BG_HEIGHT, (unsigned char*)bg, 0, 0, BG_WIDTH, BG_HEIGHT);
			GpRectFill ( NULL, &gpDraw[nflip], 108,-1,104,202, 0x33 );
			GpRectFill ( NULL, &gpDraw[nflip], 239,44,52, 47, 0x33 );
			GpRectFill ( NULL, &gpDraw[nflip], 109,-1,102,201, 0x00 );
			GpRectFill ( NULL, &gpDraw[nflip], 240,45,50,45, 0x00 );

			DrawBlock();
			DrawNextBlock();
		}
		else 
		{
			GpBitBlt(NULL, &gpDraw[nflip], 0, 0, BG_WIDTH, BG_HEIGHT, (unsigned char*)tet_bg, 0, 0, BG_WIDTH, BG_HEIGHT);
			gp_str_func.sprintf( tmp_string2, "! Press Start !");
			GpTextOut(NULL, &gpDraw[nflip], 115, 100, (char*)tmp_string2, 0xff);
		}

		gp_str_func.sprintf( tmp_string, "HighScore=%d \nScore=%d", HiScore, FullLineNum);
		GpTextOut(NULL, &gpDraw[nflip], 5, 4, (char*)tmp_string, 0xE0);

		if (PlayerState==WAIT)
		{
			gp_str_func.sprintf( tmp_string2, "Game Over\nPress Start");
			GpTextOut(NULL, &gpDraw[nflip], 115, 100, (char*)tmp_string2, 0xFF);
		}

		if (Pause==OFF)
		{
			gp_str_func.sprintf( tmp_string2, "!! Pause !!");
			GpTextOut(NULL, &gpDraw[nflip], 113, 100, (char*)tmp_string2, 0xFF);
		}

		GpSurfaceFlip(&gpDraw[nflip++]);
		nflip &= 0x01;
	}
}

void UpdateScreenTable()
{
    int element;
	int row = 0, col=0;

	for(row=0; row<4; row++)
		for(col=0;col<4;col++)
		{
	        element=Block[BlockNum][RotateNum][row][col];
			if (element!=0)
	            Screen[NowY+row][NowX+col+1]=BlockNum+1;
	    }
}


int BlockCanMove(int x,int y)
{
    int check=0;
    int row,col;

    for(row=0;row<4;row++)
    for(col=0;col<4;col++)
        if (Block[BlockNum][RotateNum][row][col])
            check += Screen[y+row][x+col+1];

    if (check==0) return YES;
    else
        return NO;
}

void LeftMove()
{
    if (PlayerState==DEAD) return;

    if (BlockCanMove(NowX-1,NowY))
    {
        NowX--;
	}
}

void RightMove()
{
    if (PlayerState==DEAD) return;

    if (BlockCanMove(NowX+1,NowY))
    {
        NowX++;
    }
}

void Rotate()
{
    int temp;
	if (PlayerState==DEAD) return;
    temp=RotateNum;

    RotateNum++;
    RotateNum %= 4;
    if (BlockCanMove(NowX,NowY))  // RotateNum 1 ..
    {
        RotateNum=temp;
        RotateNum++;
        RotateNum %= 4;
    }
    else
        RotateNum=temp;  // ȸ Ұ 
}

void Rotate2()
{
    int temp;
	if (PlayerState==DEAD) return;
    temp=RotateNum;

    RotateNum+=3;
    RotateNum %= 4;
    if (BlockCanMove(NowX,NowY))  // RotateNum 1 ..
    {
        RotateNum=temp;
        RotateNum+=3;
        RotateNum %= 4;
    }
    else
        RotateNum=temp;  // ȸ Ұ 
}

int DownMove()
{
    if (PlayerState==DEAD) return FAIL;

    if (BlockCanMove(NowX,NowY+1))
    {
        NowY++;
        return SUCCESS;
    }
    else
    {
//	HiScore=0;
        UpdateScreenTable();
//	HiScore+=100;
//		GpTimerPause(0); //ᰣ 带 ش.  ȸ߸...  üũϴµ 尡 ⶧ Screen迭 ̻ 찡 .
		NowCheckLine=OFF;
//	HiScore+=200;
		CheckFullLine();
//	HiScore+=400;
//		GpTimerResume(0);
		NowCheckLine=ON;
//	HiScore+=10;
        InitBlockState();
//	HiScore+=20;
        return FAIL;
    }
}

void CheckFullLine()
{
    int row,col,line, temp;
    int elementNum;  // count element number

	for(row=19;row>0;row--)  // from bottom to top
    {                         // row 20  ٴ ̴. row 0  Ա ( )
        elementNum=0;
        for(col=1;col<11;col++)
		{
			if(Screen[row][col]==0)
				elementNum=100;
		}

        if (elementNum!=100) // if the line is full
        {
			temp=row;
			
//			Sound->Play(false);
			//GpThreadSleep(90);
			//DrawBlock();
            for(line=temp;line>=0;line--)
				for(col=1;col<=10;col++)
	                Screen[line][col]=Screen[line-1][col];

            for(col=1;col<=10;col++)
                Screen[0][col]=0;

			FullLineNum++;
			if (FullLineNum % 10 == 0)
			{
				Stage++;
				GpTimerKill(0);
				if(GPOS_ERR_ALREADY_USED == GpTimerOptSet(0,Stage,0,ProcTimer0))	GpTimerKill(0);
				GpTimerSet(0);
			}
            row++; // 2̻  츦 ,  ٽ ˻
        }
    }
}

void InitBlockState()
{
	NowX = 3;
	NowY = 0;
	RotateNum = 0;
    BlockNum=NextBlockNum;   // ̹  
	NextBlockNum=GpRand()%7;   //   

    DrawBlock();     //   Ա? ׸.
    DrawNextBlock(); //    ׸.
    
    if (!BlockCanMove(NowX,NowY))//   ü (, ġ   )
	{
        PlayerState = WAIT;   // ׾..!! game over
		if (HiScore<FullLineNum)
		{
			HiScore=FullLineNum;
			/********************************************************************/
			if (GpRelativePathSet("gp:\\gpmm") != SM_OK) HiScore+=10; 
			if (GpFileOpen("tet.sav", OPEN_W, &h_rfile) != SM_OK) HiScore+=20;
			if (GpFileWrite(h_rfile, &HiScore, 8) != SM_OK) HiScore+=40;
			GpFileClose(h_rfile);
			/**********************************************************************/
		}
		GpTimerKill(0);
//		Music->Stop();
		UpdateScreenTable();
	}
}

void InitScreenTable()
{
    int row,col;

    for(row=0;row<21;row++)
	{
		for(col=0;col<12;col++)
		{
	        if (row==20 || col==0 || col==11)
				Screen[row][col]=1;
			else
	            Screen[row][col]=0;
	    }
	}
}

void DrawBlock()
{
    int row,col;
	int x, y;

	for(row=0;row<20;row++)
	{
		for(col=1;col<11;col++)
		{
			switch(Screen[row][col])
			{
				case 1:
					GpRect( 110+((col-1)*10), ((row)*10), 0xE3, 0xE0);
					break;
				case 2:
					GpRect( 110+((col-1)*10), ((row)*10), 0xDC, 0xFC);
					break;
				case 3:
					GpRect( 110+((col-1)*10), ((row)*10), 0xA3, 0xF3);
					break;
				case 4:
					GpRect( 110+((col-1)*10), ((row)*10), 0xA3, 0x1C);
					break;
				case 5:
					GpRect( 110+((col-1)*10), ((row)*10), 0xA3, 0x1F);
					break;
				case 6:
					GpRect( 110+((col-1)*10), ((row)*10), 0xA3, 0xF0);
					break;
				case 7:
					GpRect( 110+((col-1)*10), ((row)*10), 0xA3, 0x03);
					break;
			}
		}
	}

	if (PlayerState!=DEAD) 
	{
		for (row = 0; row<4; row++)
		{
			for (col = 0; col<4; col++)
			{
				if (Block[BlockNum][RotateNum][row][col]>0)
				{
					x = 110+NowX*10+col*10;
					y = NowY*10 + row*10;

					switch(BlockNum)
					{
						case 0:
							GpRect( x, y, 0xE3, 0xE0);
							break;
						case 1:
							GpRect( x, y, 0xDC, 0xFC);
							break;
						case 2:
							GpRect( x, y, 0xA3, 0xF3);
							break;
						case 3:
							GpRect( x, y, 0xA3, 0x1C);
							break;
						case 4:
							GpRect( x, y, 0xA3, 0x1F);
							break;
						case 5:
							GpRect( x, y, 0xA3, 0xF0);
							break;
						case 6:
							GpRect( x, y, 0xA3, 0x03);
							break;
					}
				}
			}
		}
	}
}

void DrawNextBlock()
{
    int row,col, x, y;

    for(row=0;row<4;row++)
	    for(col=0;col<4;col++)
			if (Block[NextBlockNum][0][row][col])
			{
				x = 250+col*10;
				y = 50 + row*10;

				switch(NextBlockNum)
				{
					case 0:
						GpRect( x, y, 0xE3, 0xE0);
						break;
					case 1:
						GpRect( x, y, 0xDC, 0xFC);
						break;
					case 2:
						GpRect( x, y, 0xA3, 0xF3);
						break;
					case 3:
						GpRect( x, y, 0xA3, 0x1C);
						break;
					case 4:
						GpRect( x, y, 0xA3, 0x1F);
						break;
					case 5:
						GpRect( x, y, 0xA3, 0xF0);
						break;
					case 6:
						GpRect( x+5, y+5, 0xA3, 0x03);
						break;
				}
			}
}

void ProcTimer0(void)
{
	if (Pause != OFF && NowCheckLine!=OFF)
	{
		DownMove();
	}
}

void GpRect( int left, int top, unsigned char color_line, unsigned char color )
{
	GpRectDraw( &gpDraw[nflip], left, top, left+10, top+10, color_line );
	GpRectFill( NULL, &gpDraw[nflip], left+1, top+1, 9, 9, color );
}
